// ********************************
// ***** SAT Collision ][ cpp *****
// ********************************

// A more advanced version of SAT Collision, using the C++ extensions.  This demo
// demonstrates the C++ interface for the callback routines and  for collision handling.
// What has happened is that the apples switch between good and bad, and we are not
// supposed to eat one when it's bad.

// program CollisionII;

#include "sC2MrEgghead.h"
#include "sC2Apple.h"
#include <cMaxspeed.h>

void Initialize()
{
	SATInitToolbox();
	NoFaceLoadProc();
	
	SATConfigure(true, kVPositionSort, kBackwardCollision, 32);
	SATInit(128, 129, 512, 322);

	ShowWindow(gSAT.wind.port);
	SelectWindow(gSAT.wind.port);
	SATRedraw();
	
	HideCursor();

	SATSoundInitChannels(2);		// Get two channels if possible, since
									// we use fairly long sounds.
}

void main()
{
	sC2MrEgghead myMrEgghead;
	
	new sC2Apple(POINT(0, SATRand(gSAT.offSizeV - 32)));

	while (!Button()) {
		SPEEDLIMIT(30);		// Maximum Speed 30 fps
		SATRun(true);
		
		// Start a new sprite once in a while.
		
		if (SATRand(40) == 1)
			new sC2Apple(POINT(0, SATRand(gSAT.offSizeV - 32)));
	};
	ShowCursor();
}